<%
'* Program:      download.asp   
'* Installation: Office of Comptroller General
'* Program Name: Download Data to CSV
'*  
'* Program Desc: Download Proptax MDB to comma-delimited files
'*
'* Maintenance Log:
'* 1999/08/01  JWD  Initial version
'* 2000/06/01  TMB  Added TaxCollTechSch_Spcl & TaxCollSpclDist_Spcl to download
%>
<%
 Set asplObj=Server.CreateObject("ASPL.Login")
 asplObj.Group("cg")
 asplObj.Protect
 Set asplObj=Nothing
%>

<html><head>
<TITLE>Download PropTax Data</TITLE>
</head><body bgcolor="#FFFFFF" leftmargin=0 topmargin=0>
<!--#include file="county.inc"-->
<br>
<table>
<tr>
<td width=10>
<td>

<%
DataDir="c:\inetpub\database/"
CountyFN="county.csv"
MunicFN="munic.csv"
DistrictFN="district.csv"
showblank=""
shownull=""
linestart=""
lineend=chr(34)
delimiter=chr(34) & "," & chr(34)
delimitersub=""

'*
'* Download county data 
'*
'* Note: Municipality data is written to separate file
'*
whichFN=DataDir & CountyFN  

Set fstemp = server.CreateObject("Scripting.FileSystemObject")
Set filetemp = fstemp.CreateTextFile(whichFN, true)
' true = file can be over-written if it exists
' false = file CANNOT be over-written if it exists

myDSN="DSN=proptax"
set conn=server.createobject("adodb.connection")
conn.open myDSN
mySQL="select * from CountyData"
set rstemp=conn.execute(mySQL)

' this code detects if data is empty
If  rstemp.eof then
   response.write "No data to convert for SQL statement<br>"
   response.write mySQL & "<br>"
   connection.close
   set connection=nothing
   response.end
end if

' Write field names to file
thisline=linestart & chr(34)
for each whatever in rstemp.fields
  if not (left(whatever.name, 5) = "Munic" or left(whatever.name, 5) = "NoVeh" or left(whatever.name, 9) = "AssessVal" or left(whatever.name, 7) = "TaxColl") then
    thisfield=whatever.name
    thisline=thisline & thisfield & delimiter 
  end if
  if whatever.name = "TaxCollTechSch_Spcl" or whatever.name = "TaxCollSpclDist_Spcl" then
    thisfield=whatever.name
    thisline=thisline & thisfield & delimiter 
  end if
next

tempLen=len(thisline)
tempLenDelim=len(delimiter)
thisline=mid(thisline,1,tempLEN-tempLenDelim) & lineend
filetemp.WriteLine(thisline)

' Write data to file
DO  UNTIL rstemp.eof
   thisline=linestart
   for each whatever in rstemp.fields
     if not (left(whatever.name, 5) = "Munic" or left(whatever.name, 5) = "NoVeh" or left(whatever.name, 9) = "AssessVal" or left(whatever.name, 7) = "TaxColl") then
       thisfield=whatever.value
       if isnull(thisfield) then
          thisfield=shownull
       end if
       if trim(thisfield)="" then
          thisfield=showblank
       end if
       thisfield=replace(thisfield,",","")
       if isNumeric(thisfield) or thisfield = "" then
         thisline=thisline & thisfield & ","
       else
         thisline=thisline & """" & thisfield & ""","
       end if
     end if
     if whatever.name = "TaxCollTechSch_Spcl" or whatever.name = "TaxCollSpclDist_Spcl" then
       thisfield=whatever.value
       if isnull(thisfield) then
          thisfield=shownull
       end if
       if trim(thisfield)="" then
          thisfield=showblank
       end if
       thisfield=replace(thisfield,",","")
       if isNumeric(thisfield) or thisfield = "" then
         thisline=thisline & thisfield & ","
       else
         thisline=thisline & """" & thisfield & ""","
       end if
     end if
   next

   tempLen=len(thisline)
   if right(thisline,2) = """," then
     thisline=mid(thisline,1,tempLEN-2) & """"
   else
     thisline=mid(thisline,1,tempLEN-1)
   end if
   filetemp.WriteLine(thisline) 
   rstemp.movenext
LOOP

filetemp.Close
set filetemp=nothing
rstemp.close
set rstemp=nothing
conn.close
set conn=nothing

'*
'* Download municipality data
'*
whichFN=DataDir & MunicFN  

Set fstemp = server.CreateObject("Scripting.FileSystemObject")
Set filetemp = fstemp.CreateTextFile(whichFN, true)
' true = file can be over-written if it exists
' false = file CANNOT be over-written if it exists

myDSN="DSN=proptax"
set conn=server.createobject("adodb.connection")
conn.open myDSN
mySQL="select * from CountyData"
set rstemp=conn.execute(mySQL)

' this code detects if data is empty
If  rstemp.eof then
   response.write "No data to convert for SQL statement<br>"
   response.write mySQL & "<br>"
   connection.close
   set connection=nothing
   response.end
end if

' Write field names to file
thisline=chr(34) & "CountyNum" & delimiter & "CountyName" & delimiter & "Municipality" _ 
  & delimiter & "NumVeh" & delimiter & "AssessedVal" & delimiter & "TaxesColl"
thisline=thisline & lineend
filetemp.WriteLine(thisline)

' Write data to file
DO  UNTIL rstemp.eof
  for i = 1 to 17
    if len(trim(rstemp("Munic" & i))) > 0 then
      thisline=linestart & rstemp("CountyNum") & "," & chr(34) & rstemp("CountyName") & chr(34) & ","
      thisline=thisline & chr(34) & rstemp("Munic" & i) & chr(34) & ","
      thisline=thisline & rstemp("NoVeh" & i) & ","
      thisline=thisline & rstemp("AssessVal" & i) & ","
      thisline=thisline & rstemp("TaxColl" & i)
      filetemp.WriteLine(thisline) 
    end if
  next
  rstemp.movenext
LOOP

filetemp.Close
set filetemp=nothing
rstemp.close
set rstemp=nothing
conn.close
set conn=nothing

'*
'* Download district data 
'*
whichFN=DataDir & DistrictFN 

Set fstemp = server.CreateObject("Scripting.FileSystemObject")
Set filetemp = fstemp.CreateTextFile(whichFN, true)
' true = file can be over-written if it exists
' false = file CANNOT be over-written if it exists

myDSN="DSN=proptax"
set conn=server.createobject("adodb.connection")
conn.open myDSN
mySQL="select * from DistrictData"
set rstemp=conn.execute(mySQL)

' this code detects if data is empty
If  rstemp.eof then
  response.write "No data to convert for SQL statement<br>"
  response.write mySQL & "<br>"
  connection.close
  set connection=nothing
  response.end
end if

' Write field names to file
thisline=linestart & chr(34)
for each whatever in rstemp.fields
  thisfield=whatever.name
  thisline=thisline & thisfield & delimiter 
next
tempLen=len(thisline)
tempLenDelim=len(delimiter)
thisline=mid(thisline,1,tempLEN-tempLenDelim) & lineend
filetemp.WriteLine(thisline)

' Write data to file
DO  UNTIL rstemp.eof
  thisline=linestart
  for each whatever in rstemp.fields
    thisfield=whatever.value
    if isnull(thisfield) then
       thisfield=shownull
    end if
    if trim(thisfield)="" then
       thisfield=showblank
    end if
    thisfield=replace(thisfield,",","")
    if isNumeric(thisfield) or thisfield = "" then
      thisline=thisline & thisfield & ","
    else
      thisline=thisline & """" & thisfield & ""","
    end if
  next
  tempLen=len(thisline)
  if right(thisline,2) = """," then
    thisline=mid(thisline,1,tempLEN-2) & """"
  else
    thisline=mid(thisline,1,tempLEN-1)
  end if
  filetemp.WriteLine(thisline) 
  rstemp.movenext
LOOP

filetemp.Close
set filetemp=nothing
rstemp.close
set rstemp=nothing
conn.close
set conn=nothing

' Show download links or error msg
If  err.number=0 then
  response.write "File was converted sucessfully!<br><br>"
  response.write "Use the following links to download:<br>"
  response.write "<a href='" 
  response.write "/propdata/" & CountyFN & "'>" & CountyFN & "</a>"
  response.write "<br>"
  response.write "<a href='" 
  response.write "/propdata/" & MunicFN & "'>" & MunicFN & "</a>"
  response.write "<br>"
  response.write "<a href='" 
  response.write "/propdata/" & DistrictFN & "'>" & DistrictFN & "</a>"
else
  response.write "VBScript Errors Occured!<br>"
  response.write "Error Number=#<b>" & err.number & "</b><br>"
  response.write "Error Desc. =<b>" & err.description & "</b><br>"
  response.write "Help Path =<b>" & err.helppath & "</b><br>"
  response.write "Native Error=<b>" & err.nativeerror & "</b><br>"
  response.write "Error Source =<b>" & err.source & "</b><br>"
  response.write "SQL State=#<b>" & err.sqlstate & "</b><br>"
end if
%>

<form method="post" action="county.asp">
<INPUT NAME="bSubmit" TYPE="submit" VALUE="Back"> to Main
</form>

</td>
</tr>
</table>

</body></html>



